﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using citas.Models;

#nullable disable

namespace citas.Migrations
{
    [DbContext(typeof(CitasContext))]
    [Migration("20240111231858_migrations")]
    partial class migrations
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "7.0.13")
                .HasAnnotation("Relational:MaxIdentifierLength", 128);

            SqlServerModelBuilderExtensions.UseIdentityColumns(modelBuilder);

            modelBuilder.Entity("MedicosPaciente", b =>
                {
                    b.Property<int>("MedicoId")
                        .HasColumnType("int")
                        .HasColumnName("MEDICO_ID");

                    b.Property<int>("PacienteId")
                        .HasColumnType("int")
                        .HasColumnName("PACIENTE_ID");

                    b.HasKey("MedicoId", "PacienteId")
                        .HasName("MEDICOS_PACIENTES_PK");

                    b.HasIndex("PacienteId");

                    b.ToTable("MEDICOS_PACIENTES", (string)null);
                });

            modelBuilder.Entity("citas.Models.Cita", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasColumnName("ID");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<int>("Attrib11")
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("int")
                        .HasColumnName("Attrib11");

                    b.Property<DateTime?>("FechaHora")
                        .HasColumnType("datetime")
                        .HasColumnName("FECHA_HORA");

                    b.Property<int>("MedicoId")
                        .HasColumnType("int")
                        .HasColumnName("MEDICO_ID");

                    b.Property<string>("MotivoCita")
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("varchar(255)")
                        .HasColumnName("MOTIVO_CITA");

                    b.Property<int>("PacienteId")
                        .HasColumnType("int")
                        .HasColumnName("PACIENTE_ID");

                    b.HasKey("Id")
                        .HasName("PK__CITAS__3214EC27F6B3691D");

                    b.HasIndex("MedicoId");

                    b.HasIndex("PacienteId");

                    b.ToTable("CITAS", (string)null);
                });

            modelBuilder.Entity("citas.Models.Diagnostico", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasColumnName("ID");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<int>("CitaId")
                        .HasColumnType("int")
                        .HasColumnName("CITA_ID");

                    b.Property<string>("Enfermedad")
                        .IsRequired()
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("varchar(255)")
                        .HasColumnName("ENFERMEDAD");

                    b.Property<string>("ValoracionEspecialista")
                        .IsRequired()
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("varchar(255)")
                        .HasColumnName("VALORACION_ESPECIALISTA");

                    b.HasKey("Id");

                    b.HasIndex("CitaId");

                    b.ToTable("DIAGNOSTICOS", (string)null);
                });

            modelBuilder.Entity("citas.Models.Usuario", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasColumnName("ID");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<string>("Apellidos")
                        .IsRequired()
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("varchar(255)")
                        .HasColumnName("APELLIDOS");

                    b.Property<string>("Clave")
                        .IsRequired()
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("varchar(255)")
                        .HasColumnName("CLAVE");

                    b.Property<string>("Nombre")
                        .IsRequired()
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("varchar(255)")
                        .HasColumnName("NOMBRE");

                    b.Property<string>("Usuario1")
                        .IsRequired()
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("varchar(255)")
                        .HasColumnName("USUARIO");

                    b.HasKey("Id");

                    b.ToTable("USUARIOS", (string)null);

                    b.UseTptMappingStrategy();
                });

            modelBuilder.Entity("citas.Models.Medico", b =>
                {
                    b.HasBaseType("citas.Models.Usuario");

                    b.Property<string>("NumColegiado")
                        .IsRequired()
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("varchar(255)")
                        .HasColumnName("NUM_COLEGIADO");

                    b.ToTable("MEDICOS", (string)null);
                });

            modelBuilder.Entity("citas.Models.Paciente", b =>
                {
                    b.HasBaseType("citas.Models.Usuario");

                    b.Property<string>("Direccion")
                        .IsRequired()
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("varchar(255)")
                        .HasColumnName("DIRECCION");

                    b.Property<string>("Nss")
                        .IsRequired()
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("varchar(255)")
                        .HasColumnName("NSS");

                    b.Property<string>("NumTarjeta")
                        .IsRequired()
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("varchar(255)")
                        .HasColumnName("NUM_TARJETA");

                    b.Property<string>("Telefono")
                        .IsRequired()
                        .HasMaxLength(255)
                        .IsUnicode(false)
                        .HasColumnType("varchar(255)")
                        .HasColumnName("TELEFONO");

                    b.ToTable("PACIENTES", (string)null);
                });

            modelBuilder.Entity("MedicosPaciente", b =>
                {
                    b.HasOne("citas.Models.Medico", null)
                        .WithMany()
                        .HasForeignKey("MedicoId")
                        .IsRequired()
                        .HasConstraintName("FK_MEDICOS_PACIENTES_MEDICO_ID");

                    b.HasOne("citas.Models.Paciente", null)
                        .WithMany()
                        .HasForeignKey("PacienteId")
                        .IsRequired()
                        .HasConstraintName("FK_PACIENTES_MEDICOS_PACIENTE_ID");
                });

            modelBuilder.Entity("citas.Models.Cita", b =>
                {
                    b.HasOne("citas.Models.Medico", "Medico")
                        .WithMany("Citas")
                        .HasForeignKey("MedicoId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("FK_CITAS_MEDICO_ID");

                    b.HasOne("citas.Models.Paciente", "Paciente")
                        .WithMany("Citas")
                        .HasForeignKey("PacienteId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("FK_CITAS_PACIENTE_ID");

                    b.Navigation("Medico");

                    b.Navigation("Paciente");
                });

            modelBuilder.Entity("citas.Models.Diagnostico", b =>
                {
                    b.HasOne("citas.Models.Cita", "Cita")
                        .WithMany("Diagnosticos")
                        .HasForeignKey("CitaId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("FK_DIAGNOSTICOS_CITA_ID");

                    b.Navigation("Cita");
                });

            modelBuilder.Entity("citas.Models.Medico", b =>
                {
                    b.HasOne("citas.Models.Usuario", null)
                        .WithOne()
                        .HasForeignKey("citas.Models.Medico", "Id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("citas.Models.Paciente", b =>
                {
                    b.HasOne("citas.Models.Usuario", null)
                        .WithOne()
                        .HasForeignKey("citas.Models.Paciente", "Id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("citas.Models.Cita", b =>
                {
                    b.Navigation("Diagnosticos");
                });

            modelBuilder.Entity("citas.Models.Medico", b =>
                {
                    b.Navigation("Citas");
                });

            modelBuilder.Entity("citas.Models.Paciente", b =>
                {
                    b.Navigation("Citas");
                });
#pragma warning restore 612, 618
        }
    }
}
